/* outbreak.h
 * 
 * Copyright 2012 Hajo Möller <mail@dasjoe.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 */


#ifndef OUTBREAK_H
#define OUTBREAK_H

// stackoverflow.com to the rescue - http://stackoverflow.com/questions/1644868
//~ #define debug_print(fmt, ...) do { if (DEBUG) fprintf(stderr, "%s:%d:%s(): \x1b[1;34mprintf(%s, %s);\x1b[0m\n\x1b[0;36m" fmt "\x1b[0m\n\n", __FILE__, __LINE__, __func__, #fmt, #__VA_ARGS__, __VA_ARGS__); } while (0)
#define debug_print(fmt, ...)                                                              \
	do {                                                                                     \
		if (DEBUG)                                                                             \
			fprintf(stderr, "%s:%d:%s(): " fmt "\n", __FILE__, __LINE__, __func__, __VA_ARGS__); \
	} while (0)

typedef struct s_person PERSON;

typedef struct s_area AREA;

void init_world(void);
int make_world(void);
void print_text(AREA *world);
void print_ppm(AREA *world);
int run_simulation(AREA *world);
void infect_person(AREA *world);
//~ void free_world(AREA *world);

#define WATER 1
//~ #define LAND 2

//~ typedef enum areatype areatype;

unsigned time_seed() {
	time_t now = time (0);
	unsigned char *p = (unsigned char *)&now;
	unsigned seed = 0;
	size_t i;

	for (i = 0; i < sizeof now; i++)
		seed = seed * (UCHAR_MAX + 2U) + p[i];

	return seed;
}

double uniform_deviate (int seed) {
	return seed * (1.0 / ( RAND_MAX + 1.0));
}

#endif
